glibmm 2.56.0

Public Member Functions | Static Public Member Functions | Related Functions | List of all members
Gio::FileInputStream Class Reference
Stream Classes

FileInputStream provides input streams that take their content from a file. More...

`#include <giomm/fileinputstream.h>`

Inheritance diagram for Gio::FileInputStream:
[legend]

## Public Member Functions
| FileInputStream (FileInputStream&& src) noexcept
FileInputStream& | operator= (FileInputStream&& src) noexcept
| ~FileInputStream () noexcept override
GFileInputStream* | gobj ()
| Provides access to the underlying C GObject. More...
const GFileInputStream* | gobj () const
| Provides access to the underlying C GObject. More...
GFileInputStream* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
Glib::RefPtr< FileInfo > | query_info (const Glib::RefPtr< Cancellable >& cancellable, const std::string& attributes="*")
| Queries a file input stream the given attributes. More...
Glib::RefPtr< FileInfo > | query_info (const std::string& attributes="*")
| Queries a file input stream the given attributes. More...
void | query_info_async (const SlotAsyncReady& slot, const Glib::RefPtr< Cancellable >& cancellable, const std::string& attributes="*", int io_priority=Glib::PRIORITY_DEFAULT)
| Queries the stream information asynchronously. More...
void | query_info_async (const SlotAsyncReady& slot, const std::string& attributes="*", int io_priority=Glib::PRIORITY_DEFAULT)
| Queries the stream information asynchronously. More...
Glib::RefPtr< FileInfo > | query_info_finish (const Glib::RefPtr< AsyncResult >& result)
| Finishes an asynchronous info query operation. More...
Public Member Functions inherited from Gio::InputStream
| InputStream (InputStream&& src) noexcept
InputStream& | operator= (InputStream&& src) noexcept
| ~InputStream () noexcept override
GInputStream* | gobj ()
| Provides access to the underlying C GObject. More...
const GInputStream* | gobj () const
| Provides access to the underlying C GObject. More...
GInputStream* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
gssize | read (void* buffer, gsize count, const Glib::RefPtr< Cancellable >& cancellable)
| Tries to read count bytes from the stream into the buffer starting at buffer. More...
gssize | read (void* buffer, gsize count)
| A read() convenience overload. More...
bool | read_all (void* buffer, gsize count, gsize& bytes_read, const Glib::RefPtr< Cancellable >& cancellable)
| Tries to read count bytes from the stream into the buffer starting at buffer. More...
bool | read_all (void* buffer, gsize count, gsize& bytes_read)
| A read_all() convenience overload. More...
Glib::RefPtr< Glib::Bytes > | read_bytes (gsize count, const Glib::RefPtr< Cancellable >& cancellable)
| Like g_input_stream_read(), this tries to read count bytes from the stream in a blocking fashion. More...
void | read_bytes_async (gsize count, const SlotAsyncReady& slot, const Glib::RefPtr< Cancellable >& cancellable, int io_priority=Glib::PRIORITY_DEFAULT)
| Request an asynchronous read of count bytes from the stream into a new Glib::Bytes. More...
void | read_bytes_async (gsize count, const SlotAsyncReady& slot, int io_priority=Glib::PRIORITY_DEFAULT)
| Request an asynchronous read of count bytes from the stream into a new Glib::Bytes. More...
Glib::RefPtr< Glib::Bytes > | read_bytes_finish (const Glib::RefPtr< AsyncResult >& result)
| Finishes an asynchronous stream read-into-Bytes operation. More...
gssize | skip (gsize count, const Glib::RefPtr< Cancellable >& cancellable)
| Tries to skip count bytes from the stream. More...
gssize | skip (gsize count)
| A skip() convenience overload. More...
bool | close (const Glib::RefPtr< Cancellable >& cancellable)
| Closes the stream, releasing resources related to it. More...
bool | close ()
| A close() convenience overload. More...
void | read_async (void* buffer, gsize count, const SlotAsyncReady& slot, const Glib::RefPtr< Cancellable >& cancellable, int io_priority=Glib::PRIORITY_DEFAULT)
| Request an asynchronous read of count bytes from the stream into the buffer starting at buffer. More...
void | read_async (void* buffer, gsize count, const SlotAsyncReady& slot, int io_priority=Glib::PRIORITY_DEFAULT)
| Request an asynchronous read of count bytes from the stream into the buffer starting at buffer. More...
gssize | read_finish (const Glib::RefPtr< AsyncResult >& result)
| Finishes an asynchronous stream read operation. More...
void | read_all_async (void* buffer, gsize count, const SlotAsyncReady& slot, const Glib::RefPtr< Cancellable >& cancellable, int io_priority=Glib::PRIORITY_DEFAULT)
| Request an asynchronous read of count bytes from the stream into the buffer starting at buffer. More...
void | read_all_async (void* buffer, gsize count, const SlotAsyncReady& slot, int io_priority=Glib::PRIORITY_DEFAULT)
| Request an asynchronous read of count bytes from the stream into the buffer starting at buffer. More...
bool | read_all_finish (const Glib::RefPtr< AsyncResult >& result, gsize& bytes_read)
| Finishes an asynchronous stream read operation started with g_input_stream_read_all_async(). More...
void | skip_async (gsize count, const SlotAsyncReady& slot, const Glib::RefPtr< Cancellable >& cancellable, int io_priority=Glib::PRIORITY_DEFAULT)
| Request an asynchronous skip of count bytes from the stream into the buffer starting at buffer. More...
void | skip_async (gsize count, const SlotAsyncReady& slot, int io_priority=Glib::PRIORITY_DEFAULT)
| Request an asynchronous skip of count bytes from the stream into the buffer starting at buffer. More...
gssize | skip_finish (const Glib::RefPtr< AsyncResult >& result)
| Finishes a stream skip operation. More...
void | close_async (const SlotAsyncReady& slot, const Glib::RefPtr< Cancellable >& cancellable, int io_priority=Glib::PRIORITY_DEFAULT)
| Requests an asynchronous closes of the stream, releasing resources related to it. More...
void | close_async (const SlotAsyncReady& slot, int io_priority=Glib::PRIORITY_DEFAULT)
| Requests an asynchronous closes of the stream, releasing resources related to it. More...
gboolean | close_finish (const Glib::RefPtr< AsyncResult >& result)
| Finishes closing a stream asynchronously, started from g_input_stream_close_async(). More...
bool | is_closed () const
| Checks if an input stream is closed. More...
bool | has_pending () const
| Checks if an input stream has pending actions. More...
Public Member Functions inherited from Glib::Object
| Object (const Object&)=delete
Object& | operator= (const Object&)=delete
| Object (Object&& src) noexcept
Object& | operator= (Object&& src) noexcept
void* | get_data (const QueryQuark& key)
void | set_data (const Quark& key, void* data)
void | set_data (const Quark& key, void* data, DestroyNotify notify)
void | remove_data (const QueryQuark& quark)
void* | steal_data (const QueryQuark& quark)
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase&)=delete
ObjectBase& | operator= (const ObjectBase&)=delete
void | set_property_value (const Glib::ustring& property_name, const Glib::ValueBase& value)
| You probably want to use a specific property_*() accessor method instead. More...
void | get_property_value (const Glib::ustring& property_name, Glib::ValueBase& value) const
| You probably want to use a specific property_*() accessor method instead. More...
template<class PropertyType >
void | set_property (const Glib::ustring& property_name, const PropertyType& value)
| You probably want to use a specific property_*() accessor method instead. More...
template<class PropertyType >
void | get_property (const Glib::ustring& property_name, PropertyType& value) const
| You probably want to use a specific property_*() accessor method instead. More...
void | connect_property_changed (const Glib::ustring& property_name, const sigc::slot< void >& slot)
| You can use the signal_changed() signal of the property proxy instead. More...
void | connect_property_changed (const Glib::ustring& property_name, sigc::slot< void >&& slot)
| You can use the signal_changed() signal of the property proxy instead. More...
sigc::connection | connect_property_changed_with_return (const Glib::ustring& property_name, const sigc::slot< void >& slot)
| You can use the signal_changed() signal of the property proxy instead. More...
sigc::connection | connect_property_changed_with_return (const Glib::ustring& property_name, sigc::slot< void >&& slot)
| You can use the signal_changed() signal of the property proxy instead. More...
void | freeze_notify ()
| Increases the freeze count on object. More...
void | thaw_notify ()
| Reverts the effect of a previous call to freeze_notify(). More...
virtual void | reference () const
| Increment the reference count for this object. More...
virtual void | unreference () const
| Decrement the reference count for this object. More...
GObject* | gobj ()
| Provides access to the underlying C GObject. More...
const GObject* | gobj () const
| Provides access to the underlying C GObject. More...
GObject* | gobj_copy () const
| Give a ref-ed copy to someone. Use for direct struct access. More...
Public Member Functions inherited from sigc::trackable
| trackable () noexcept
| trackable (const trackable &src) noexcept
| trackable (trackable &&src)
| ~trackable ()
void | add_destroy_notify_callback (void *data, func_destroy_notify func) const
void | notify_callbacks ()
trackable & | operator= (const trackable &src)
trackable & | operator= (trackable &&src)
void | remove_destroy_notify_callback (void *data) const
Public Member Functions inherited from Gio::Seekable
| Seekable (Seekable&& src) noexcept
Seekable& | operator= (Seekable&& src) noexcept
| ~Seekable () noexcept override
GSeekable* | gobj ()
| Provides access to the underlying C GObject. More...
const GSeekable* | gobj () const
| Provides access to the underlying C GObject. More...
goffset | tell () const
| Tells the current position within the stream. More...
bool | can_seek () const
| Tests if the stream supports the SeekableIface. More...
bool | seek (goffset offset, Glib::SeekType type, const Glib::RefPtr< Cancellable >& cancellable)
| Seeks in the stream by the given offset, modified by type. More...
bool | seek (goffset offset, Glib::SeekType type)
| A seek() convenience overload. More...
bool | can_truncate () const
| Tests if the length of the stream can be adjusted with g_seekable_truncate(). More...
bool | truncate (goffset offset, const Glib::RefPtr< Cancellable >& cancellable)
| Truncates a stream with a given #offset. More...
bool | truncate (goffset offset)
| A truncate() convenience overload. More...
Public Member Functions inherited from Glib::Interface
| Interface ()
| A Default constructor. More...
| Interface (Interface&& src) noexcept
Interface& | operator= (Interface&& src) noexcept
| Interface (const Glib::Interface_Class& interface_class)
| Called by constructors of derived classes. More...
| Interface (GObject* castitem)
| Called by constructors of derived classes. More...
| ~Interface () noexcept override
| Interface (const Interface&)=delete
Interface& | operator= (const Interface&)=delete
GObject* | gobj ()
const GObject* | gobj () const

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
Static Public Member Functions inherited from Gio::InputStream
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
Static Public Member Functions inherited from Gio::Seekable
static void | add_interface (GType gtype_implementer)
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...

## Related Functions
(Note that these are not member functions.)
Glib::RefPtr< Gio::FileInputStream > | wrap (GFileInputStream* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Gio::InputStream
Glib::RefPtr< Gio::InputStream > | wrap (GInputStream* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Glib::Object
Glib::RefPtr< Glib::Object > | wrap (GObject* object, bool take_copy=false)
Related Functions inherited from Gio::Seekable
Glib::RefPtr< Gio::Seekable > | wrap (GSeekable* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...

## Additional Inherited Members
Public Types inherited from Glib::Object
using | DestroyNotify = void(*)(gpointer data)
Public Types inherited from sigc::trackable
typedef internal::func_destroy_notify | func_destroy_notify
Protected Member Functions inherited from Gio::InputStream
| InputStream ()
bool | set_pending ()
| Sets stream to have actions pending. More...
void | clear_pending ()
| Clears the pending flag on stream. More...
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams& construct_params)
| Object (GObject* castitem)
| ~Object () noexcept override
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| This default constructor is called implicitly from the constructor of user-derived classes, even if, for instance, Gtk::Button calls a different ObjectBase constructor. More...
| ObjectBase (const char* custom_type_name)
| A derived constructor always overrides this choice. More...
| ObjectBase (const std::type_info& custom_type_info)
| This constructor is a special feature to allow creation of derived types on the fly, without having to use g_object_new() manually. More...
| ObjectBase (ObjectBase&& src) noexcept
ObjectBase& | operator= (ObjectBase&& src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject* castitem)
void | initialize_move (GObject* castitem, Glib::ObjectBase* previous_wrapper)
Protected Member Functions inherited from Gio::Seekable
| Seekable ()
| You should derive from this class to use it. More...

## Detailed Description

FileInputStream provides input streams that take their content from a file.

FileInputStream implements Seekable, which allows the input stream to jump to arbitrary positions in the file, provided the file system of the file allows it. Use the methods of the Seekable base class for seeking and positioning.

Since glibmm 2.16:

## Constructor & Destructor Documentation

## ◆ FileInputStream()

Gio::FileInputStream::FileInputStream | ( | FileInputStream&& | src | ) |
| noexcept

## ◆ ~FileInputStream()

Gio::FileInputStream::~FileInputStream | ( |  | ) |
| override noexcept

## Member Function Documentation

## ◆ get_type()

static GType Gio::FileInputStream::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

## ◆ gobj() [1/2]

GFileInputStream* Gio::FileInputStream::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

## ◆ gobj() [2/2]

const GFileInputStream* Gio::FileInputStream::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

## ◆ gobj_copy()

GFileInputStream* Gio::FileInputStream::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

## ◆ operator=()

FileInputStream& Gio::FileInputStream::operator= | ( | FileInputStream&& | src | ) |
| noexcept

## ◆ query_info() [1/2]

Glib::RefPtr<FileInfo> Gio::FileInputStream::query_info | ( | const Glib::RefPtr< Cancellable >& | cancellable,
|  | const std::string & | attributes = `"*"`
| ) |  |

Queries a file input stream the given attributes.

This function blocks while querying the stream. For the asynchronous (non-blocking) version of this function, see query_info_async(). While the stream is blocked, the stream will set the pending flag internally, and any other operations on the stream will throw a Gio::Error with PENDING.

Parameters

  attributes | A file attribute query string.
  cancellable | A Cancellable object.

Returns
  A FileInfo, or an empty RefPtr on error.

## ◆ query_info() [2/2]

Glib::RefPtr<FileInfo> Gio::FileInputStream::query_info | ( | const std::string & | attributes = `"*"` | ) |

Queries a file input stream the given attributes.

This function blocks while querying the stream. For the asynchronous (non-blocking) version of this function, see query_info_async(). While the stream is blocked, the stream will set the pending flag internally, and any other operations on the stream will throw a Gio::Error with PENDING.

Parameters

  attributes | A file attribute query string.

Returns
  A FileInfo, or an empty RefPtr on error.

## ◆ query_info_async() [1/2]

void Gio::FileInputStream::query_info_async | ( | const SlotAsyncReady& | slot,
|  | const Glib::RefPtr< Cancellable >& | cancellable,
|  | const std::string & | attributes = `"*"`,
|  | int | io_priority = `Glib::PRIORITY_DEFAULT`
| ) |  |

Queries the stream information asynchronously.

For the synchronous version of this function, see query_info().

The operation can be cancelled by triggering the cancellable object from another thread. If the operation was cancelled, a Gio::Error with CANCELLED will be thrown.

When the operation is finished, slot will be called. You can then call query_info_finish() to get the result of the operation.

Parameters

  slot | A callback slot which will be called when the request is satisfied.
  cancellable | A Cancellable object which can be used to cancel the operation.
  attributes | A file attribute query string.
  io_priority | The I/O priority of the request.

## ◆ query_info_async() [2/2]

void Gio::FileInputStream::query_info_async | ( | const SlotAsyncReady& | slot,
|  | const std::string & | attributes = `"*"`,
|  | int | io_priority = `Glib::PRIORITY_DEFAULT`
| ) |  |

Queries the stream information asynchronously.

For the synchronous version of this function, see query_info().

When the operation is finished, slot will be called. You can then call query_info_finish() to get the result of the operation.

Parameters

  slot | A callback slot which will be called when the request is satisfied.
  attributes | A file attribute query string.
  io_priority | The I/O priority of the request.

## ◆ query_info_finish()

Glib::RefPtr<FileInfo> Gio::FileInputStream::query_info_finish | ( | const Glib::RefPtr< AsyncResult >& | result | ) |

Finishes an asynchronous info query operation.

Parameters

  result | A AsyncResult.

Returns
  FileInfo.

Exceptions

  Glib::Error |

## Friends And Related Function Documentation

## ◆ wrap()

Glib::RefPtr< Gio::FileInputStream > wrap | ( | GFileInputStream * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.